
--AI工具核心数据

SELECT partition_date as `日期`
      ,if(ios_new_ai_retention='0.0%','-',ios_new_ai_retention) as  `iOS新在AI功能次留`
      ,ios_new_gc_uv as `iOS新在AI分发页PVgood click/功能使用uv`
      ,if(andr_new_ai_retention='0.0%','-',andr_new_ai_retention) as `android新在AI功能次留`
      ,andr_new_gc_uv as `android新在AI分发页PVgood click/功能使用uv`

FROM
(
    SELECT t1.partition_date
        ,concat(round(count(distinct case when device_os_type ='ios' and active_type ='新增' and channel='ai' then t3.cl_id end)/count(distinct  case when device_os_type ='ios' and active_type ='新增' and channel='ai' then t2.cl_id end)*100,2),'%') as ios_new_ai_retention
        ,concat(round(sum(case when device_os_type ='ios' and active_type ='新增' and channel='ai' then gc_num end)/count(distinct case when device_os_type ='ios' and active_type ='新增' and channel='ai' then t2.cl_id end)*100,2),'%') as ios_new_gc_uv
        ,concat(round(count(distinct case when device_os_type ='android' and active_type ='新增' and channel='ai' then t3.cl_id end)/count(distinct  case when device_os_type ='android' and active_type ='新增' and channel='ai' then t2.cl_id end)*100,2),'%') as andr_new_ai_retention
        ,concat(round(sum(case when device_os_type ='android' and active_type ='新增' and channel='ai' then gc_num end)/count(distinct case when device_os_type ='android' and active_type ='新增' and channel='ai' then t2.cl_id end)*100,2),'%') as andr_new_gc_uv
    FROM
    (
        SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date
              ,device_os_type,m.device_id
              ,CASE WHEN active_type = '4' THEN '老活'  when active_type in ('1','2') then '新增' END as active_type
              ,case when is_ai_channel='true' then 'ai' else '医美' end as channel
        FROM online.ml_device_day_active_status m
            LEFT JOIN
            (SELECT code,is_spam,is_ai_channel,partition_day
                FROM DIM.DIM_AI_CHANNEL_ZP_NEW
                WHERE partition_day >=REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
                and partition_day<=REGEXP_REPLACE(current_date(),'-',''))tmp
            on first_channel_source_type=tmp.code and m.partition_date=tmp.partition_day
        WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
        and partition_date <= REGEXP_REPLACE(current_date(),'-','')
        AND active_type IN ('1','2','4')
        AND first_channel_source_type not IN ('yqxiu1','yqxiu2','yqxiu3','yqxiu4','yqxiu5','mxyc1','mxyc2','mxyc3'
                ,'wanpu','jinshan','jx','maimai','zhuoyi','huatian','suopingjingling','mocha','mizhe','meika','lamabang'
                ,'js-az1','js-az2','js-az3','js-az4','js-az5','jfq-az1','jfq-az2','jfq-az3','jfq-az4','jfq-az5','toufang1'
                ,'toufang2','toufang3','toufang4','toufang5','toufang6','TF-toufang1','TF-toufang2','TF-toufang3','TF-toufang4'
                ,'TF-toufang5','tf-toufang1','tf-toufang2','tf-toufang3','tf-toufang4','tf-toufang5','benzhan','promotion_aso100'
                ,'promotion_qianka','promotion_xiaoyu','promotion_dianru','promotion_malioaso','promotion_malioaso-shequ'
                ,'promotion_shike','promotion_julang_jl03','promotion_zuimei','','unknown')
        AND first_channel_source_type not LIKE 'promotion\_jf\_%'
    )t1

    LEFT JOIN
    (
        SELECT partition_date,cl_id,count(distinct routine) as routine_num
        FROM
        (
            SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id
                    ,concat(pre_page_name,',',page_name) as routine
            FROM
            (
                SELECT partition_date,
                    cl_id,
                    app_session_id,
                    page_name,
                    lag(page_name, 1 , 'unknown') over(partition by partition_date,cl_id,app_session_id order by no) as pre_page_name
                FROM
                (
                    SELECT partition_date,
                        cl_id,
                        app_session_id,
                        time_str,
                        page_name,
                        row_number() over (partition by partition_date,cl_id,app_session_id order by time_str asc) as no
                    FROM online.bl_hdfs_maidian_updates
                    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
                      and partition_date <= REGEXP_REPLACE(current_date(),'-','')
                      AND page_name in ('face_scan','report_result','face_detect_result','face_simulator')
                      AND action = 'page_view'
                    GROUP BY partition_date,
                           cl_id,
                           app_session_id,
                           time_str,
                           page_name
                )a
            )b
            WHERE concat(pre_page_name,',',page_name) in ('face_scan,report_result','face_scan,face_detect_result','face_scan,face_simulator')
        )c
        group by partition_date,cl_id
    )t2
        ON t1.device_id = t2.cl_id AND t1.partition_date = t2.partition_date
    LEFT JOIN
    (
        SELECT partition_date,cl_id,count(distinct routine) as routine_num
        FROM
        (
            SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id
                    ,concat(pre_page_name,',',page_name) as routine
            FROM
            (
                SELECT partition_date,
                    cl_id,
                    app_session_id,
                    page_name,
                    lag(page_name, 1 , 'unknown') over(partition by partition_date,cl_id,app_session_id order by no) as pre_page_name
                FROM
                (
                    SELECT partition_date,
                        cl_id,
                        app_session_id,
                        time_str,
                        page_name,
                        row_number() over (partition by partition_date,cl_id,app_session_id order by time_str asc) as no
                    FROM online.bl_hdfs_maidian_updates
                    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
                      and partition_date <= REGEXP_REPLACE(current_date(),'-','')
                      AND page_name in ('face_scan','report_result','face_detect_result','face_simulator')
                      AND action = 'page_view'
                    GROUP BY partition_date,
                           cl_id,
                           app_session_id,
                           time_str,
                           page_name
                )a
            )b
            WHERE concat(pre_page_name,',',page_name) in ('face_scan,report_result','face_scan,face_detect_result','face_scan,face_simulator')
        )c
        group by partition_date,cl_id
    )t3
        ON t2.cl_id = t3.cl_id AND date_add(t2.partition_date,1) = t3.partition_date
    left join
    (--ai分发页pv good click
    	--来自于ai结果页的内容的good_click（主要是测颜值和模拟整形）
    	select concat_ws('-',substr(a.partition_date,1,4),substr(a.partition_date,5,2),substr(a.partition_date,7,2)) as partition_date,a.cl_id,count(distinct a.business_id) as gc_num
    	from
    	(
    		select *,case when page_name in ('diary_detail','topic_detail') THEN 'diary'
    					  when page_name in ('post_detail','user_post_detail','doctor_post_detail') THEN 'post'
    					  when page_name in ('answer_detail') THEN 'answer' end as content_type
    		FROM ONLINE.BL_HDFS_MAIDIAN_UPDATES
    		WHERE PARTITION_DATE >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
    		and page_name in ('diary_detail','topic_detail','post_detail','user_post_detail','doctor_post_detail','question_detail','answer_detail','question_answer_detail',
    	                          'video_steep','article_detail')
    		and (referrer in ('report_result','face_detect_result','float_tag_detail') or
                  (params['referrer_link'] like '%[%' and   --增加referrer_link限制条件，因为部分页面referrer丢失
                   json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('report_result','face_detect_result','float_tag_detail')))
    	)a
    	left join
    	(--评论的埋点有缺失，所以用业务库数据来补充
    	    --日记这里取的是日记本id，因为从首页点击卡片进入后，先进入日记卡片
    	    SELECT diary_id as content_id,'diary' as type,user_id,create_date
    	    FROM
    	    (
    	        SELECT id,problem_id,user_id,regexp_replace(substr(reply_date,1,10),'-','') as create_date
    	        FROM online.tl_hdfs_topicreply_view
    	        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
    	        AND is_spam = 'false'  --排除疑似广告
    	        and is_online='true'
    	        and regexp_replace(substr(reply_date,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
    	        group by id,problem_id,user_id,reply_date
    	    )t1
    	    JOIN
    	    (
    	        SELECT id,diary_id
    	        FROM online.tl_hdfs_problem_view
    	        WHERE partition_date = regexp_replace(DATE_SUB(current_date,1) ,'-','')
    	        group by id,diary_id
    	    )t2
    	    on t2.id=t1.problem_id
    	    group by diary_id,user_id,create_date

    	    UNION ALL

    	    --有评论过回答的设备,排除疑似广告

    	    SELECT answer_id as content_id,'answer' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
    	    FROM online.tl_hdfs_answer_reply_view
    	    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
    	    and (is_fake is NULL or is_fake = 'false')
    	    AND answer_id is not NULL
    	    and is_online='true'
    	    and is_spam = 'false'  --排除疑似广告
    	    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
    	    group by answer_id,user_id,create_time

    	    UNION ALL

    	    --有评论过用户帖的设备
    	    SELECT tractate_id as content_id,'post' as type,user_id,regexp_replace(substr(create_time,1,10),'-','') as create_date
    	    FROM  online.tl_hdfs_api_tractate_reply_view
    	    WHERE partition_date =regexp_replace(DATE_SUB(current_date,1) ,'-','')
    	    and regexp_replace(substr(create_time,1,10),'-','') >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
    	    and is_online='true'
    	    group by tractate_id,user_id,create_time
    	)b
    	on a.business_id=b.content_id and a.partition_date=b.create_date and a.user_id=b.user_id and a.content_type=b.type
    	WHERE ((action='page_view' and page_stay>=20)--浏览时长大约20s
    			 or action in ('on_click_navbar_search','do_search') --二跳：点击搜索框和搜索按钮
    			 or (action='on_click_card' and params['card_type']='highlight_word')--二跳：高亮词
    			 or (action='on_click_card' and params['card_content_type']in ('service','qa','diary','user_post','answer'))--二跳：点击卡片
    			 or (action='on_click_button' and params['button_name'] in ('video_interview','referral'))--二跳：点击转诊和视频面诊
    			 or (action='on_click_favor' and params['motion']='do')--点击收藏
    			 or action='page_click_share'--点击分享
    			 or (action='on_click_vote' and params['motion']='vote')--点击点赞
    			 or b.user_id is not null )--当天有针对内容的评论
    	group by a.partition_date,a.cl_id

        union all

        --在ai结果页中点击了商详卡片（主要是测肤结果页）

    	SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id,count(distinct business_id) as gc_num
    	FROM online.bl_hdfs_maidian_updates
    	WHERE  partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
    	and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
    	AND ((action in ('welfare_multiattribute_click_add','welfare_multiattribute_click_buy','on_click_navbar_cart') AND page_name = 'welfare_detail')--点击加车
    			or action = 'welfare_detail_click_message'--点击私信
    			or (action = 'on_click_button' AND page_name = 'welfare_detail' AND params['button_name'] in ('question_tag','appointment'))--点击人工咨询+预约面诊
    			or (action = 'welfare_detail_click_curearea_contact' AND params['connect_type'] in ('phone','onlineconsult'))--点击电话咨询/在线咨询
    			or (action='welfare_detail_click_curearea' AND params['cure_type'] in ('doctor','organization'))--点击医生/医院
    			or (action in ('page_click_share','welfare_detail_comment_click_diary_card','service_comment_click_tag')AND page_name='welfare_detail')---点击分享+评价列表页
    			or (action='welfare_detail_click_close_float_coupon'AND page_name='welfare_detail')--点击上浮窗美券
    			or (action='welfare_detail_click_coupon' AND params['coupon_type'] in ('precoupon','finalcoupon'))--点击美券
    			----or(action='on_click_button' AND params['button_name'] in ('sku_choose','sku_all','service_sku')AND page_name='welfare_detail'))--点击美购项目
    			or (action in ('welfare_detail_click_comment','welfare_detail_click_all_user_case','on_click_diary_card','welfare_detail_click_seller_service_item'))---点击日记/评价/横滑美购
    			or (action ='on_click_button' AND params['page_name'] in ('welfare_detail') AND params['popup_name'] in ('consult_reserved','consult_call') AND params['trigger'] in ('stay_long','uncontact','view_step')  AND params['button_name'] in ('message','call','reserved'))---点击电话/私信弹窗
    			or (action='on_click_card' AND params['card_content_type']='service' AND params['tab_name']='推荐' AND page_name = 'welfare_detail')--点击推荐美购
    			or (action ='on_click_favor' AND page_name = 'welfare_detail' AND params['favor_type']='service' AND params['motion']='do'))--点击收藏
    	and (referrer in ('report_result','face_detect_result','float_tag_detail') or
                  (params['referrer_link'] like '%[%' and   --增加referrer_link限制条件，因为部分页面referrer丢失
                   json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('report_result','face_detect_result','float_tag_detail')))
    	group by partition_date,cl_id

    	union all

    	--在结果页的去别的功能以及视频面诊按钮
    	SELECT concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id,count(distinct time_str) as gc_num
        FROM  online.bl_hdfs_maidian_updates
        WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
        and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
        AND action = 'on_click_button'
        and params['page_name'] in ('report_result','face_detect_result')   --测肤结果页点击完成、再测一次、扫脸、视频面诊
        AND params['button_name'] in ('ai_function','video_interview','AI测肤质','视频面诊','AI测颜值')
        group by cl_id,partition_date

        union all

        --在测肤和测颜值中点击了专业问答或讨论小组到搜索或小组页

        select concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id,count(distinct business_id) as gc_num
        from online.bl_hdfs_maidian_updates
        where partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
        and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
        and ((action='page_view' and page_stay>=20)
               or (action='on_click_card' and params['card_type']='card'))
        and page_name in ('search_result_question_answer','topic_aggregation')
        and (referrer in ('report_result','face_detect_result') or
                  (params['referrer_link'] like '%[%' and   --增加referrer_link限制条件，因为部分页面referrer丢失
                   json_split(params['referrer_link'])[size(json_split(params['referrer_link']))-1] in ('report_result','face_detect_result','float_tag_detail')))
        group by partition_date,cl_id

        union all

        --在模拟整形结果页点击方案下面三个按钮

        select concat_ws('-',substr(partition_date,1,4),substr(partition_date,5,2),substr(partition_date,7,2)) as partition_date,cl_id,count(distinct time_str) as gc_num
        from online.bl_hdfs_maidian_updates
        where partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),1),'MM'),'-','')
        and partition_date <= regexp_replace(DATE_SUB(current_date,1) ,'-','')
        and action='on_click_button'
        and page_name = 'float_tag_detail'
        and params['button_name'] in ('consult','bargain','commodity_ranking')
        group by partition_date,cl_id
    )t4
    	on t1.partition_date=t4.partition_date and t1.device_id=t4.cl_id
    left join
    ( -- 去掉黑名单设备
        select distinct device_id
        from ML.ML_D_CT_DV_DEVICECLEAN_DIMEN_D
        where PARTITION_DAY = regexp_replace(DATE_SUB(current_date,1) ,'-','')
        AND is_abnormal_device = 'true'
    )spam_pv
    on t1.device_id =spam_pv.device_id
    WHERE spam_pv.device_id IS NULL
    GROUP BY
        t1.partition_date
)t
order by `日期`;
