--***************************************************************
--*脚本名称:
--*功能: 首页icon及功能区数据
--*业务名称: pm
--*输入数据:
--*作者: yindanlei@igengmei.com
--*更新时间:2020-09-23
--***************************************************************

--设置全局变量&UDF
SET mapreduce.job.queuename=data;

--使用bl数据库
USE pm;

--创建BL层内部表
CREATE TABLE IF NOT EXISTS pm.tl_pm_icon_function_d
(
 date string comment '{"chs_name":"日期","description":"","etl":"","value":"","remark":""}',
 grey_type string comment '{"chs_name":"灰度","description":"","etl":"","value":"","remark":""}',
 dau BIGINT comment '{"chs_name":"dau","description":"","etl":"","value":"","remark":""}',
 dau_733 BIGINT comment '{"chs_name":"7.33版本及以上dau","description":"","etl":"","value":"","remark":""}',
 gengxinlv string comment '{"chs_name":"版本更新率","description":"","etl":"","value":"","remark":""}',
 quanzhong_dau string comment '{"chs_name":"权重日活","description":"","etl":"","value":"","remark":""}',
 ciliu string comment '{"chs_name":"次留率","description":"","etl":"","value":"","remark":""}',
 function_click_pv_rate string comment '{"chs_name":"功能入口点击率pv","description":"","etl":"","value":"","remark":""}',
 function_click_uv_rate string comment '{"chs_name":"功能入口点击率uv","description":"","etl":"","value":"","remark":""}',
 icon_click_pv_rate string comment '{"chs_name":"icon点击率pv","description":"","etl":"","value":"","remark":""}',
 icon_click_uv_rate string comment '{"chs_name":"icon点击率uv","description":"","etl":"","value":"","remark":""}',
 refer_function_wel_pv_rate string comment '{"chs_name":"通过功能区到商详页pv占比","description":"","etl":"","value":"","remark":""}',
 refer_function_wel_uv_rate string comment '{"chs_name":"通过功能区到商详页uv占比","description":"","etl":"","value":"","remark":""}',
 refer_icon_wel_pv_rate string comment '{"chs_name":"通过icon到商详页pv占比","description":"","etl":"","value":"","remark":""}',
 refer_icon_wel_uv_rate string comment '{"chs_name":"通过icon到商详页uv占比","description":"","etl":"","value":"","remark":""}',
 click_function_pv string comment '{"chs_name":"功能入口点击pv","description":"","etl":"","value":"","remark":""}',
 click_function_uv string comment '{"chs_name":"功能入口点击uv","description":"","etl":"","value":"","remark":""}',
 exp_function_pv string comment '{"chs_name":"功能入口曝光pv","description":"","etl":"","value":"","remark":""}',
 exp_function_uv string comment '{"chs_name":"功能入口曝光uv","description":"","etl":"","value":"","remark":""}',
 click_icon_pv string comment '{"chs_name":"icon点击pv","description":"","etl":"","value":"","remark":""}',
 click_icon_uv string comment '{"chs_name":"icon点击uv","description":"","etl":"","value":"","remark":""}',
 exp_icon_pv string comment '{"chs_name":"icon曝光pv","description":"","etl":"","value":"","remark":""}',
 exp_icon_uv string comment '{"chs_name":"icon曝光uv","description":"","etl":"","value":"","remark":""}',
 wel_pv string comment '{"chs_name":"商详页浏览pv","description":"","etl":"","value":"","remark":""}',
 wel_uv string comment '{"chs_name":"商详页浏览uv","description":"","etl":"","value":"","remark":""}',
 wel_function_pv string comment '{"chs_name":"通过功能区到商详页pv","description":"","etl":"","value":"","remark":""}',
 wel_function_uv string comment '{"chs_name":"通过功能区到商详页uv","description":"","etl":"","value":"","remark":""}',
 wel_icon_pv string comment '{"chs_name":"通过icon到商详页pv","description":"","etl":"","value":"","remark":""}',
 wel_icon_uv string comment '{"chs_name":"通过icon到商详页uv","description":"","etl":"","value":"","remark":""}',
 neirong_icon_pv string comment '{"chs_name":"通过icon到内容页pv","description":"","etl":"","value":"","remark":""}',
 neirong_icon_uv string comment '{"chs_name":"通过icon到内容页uv","description":"","etl":"","value":"","remark":""}',
 all_two_pv string comment '{"chs_name":"通过icon总二跳pv","description":"","etl":"","value":"","remark":""}',
 all_two_uv string comment '{"chs_name":"通过icon总二跳uv","description":"","etl":"","value":"","remark":""}'
 )comment '首页icon及功能区数据'
PARTITIONED BY (PARTITION_DAY STRING comment '分区日期')
ROW FORMAT DELIMITED
FIELDS TERMINATED BY '\t'
COLLECTION ITEMS TERMINATED BY '\002'
MAP KEYS TERMINATED BY '\003'
LINES TERMINATED BY '\n'
STORED AS TEXTFILE;