SET mapreduce.job.queuename=data;
SET mapreduce.map.memory.mb=8192;
SET mapreduce.map.java.opts=-Xmx8000m;
SET mapreduce.reduce.memory.mb=8192;
SET mapreduce.reduce.java.opts=-Xmx8000m;
set hive.auto.convert.join=true;
SET mapred.reduce.tasks=20;
SET role admin;


INSERT OVERWRITE TABLE pm.tl_pm_yeji_d PARTITION (PARTITION_DAY = ${partition_day})

SELECT nvl(nvl(nvl(nvl(nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date),t4.partition_date),t5.partition_date),t6.partition_date),t7.partition_date) as data
  ,nvl(nvl(nvl(nvl(nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name),t4.hospital_name),t5.hospital_name),t6.hospital_name),t7.hospital_name) as hospital_name
  ,nvl(nvl(nvl(nvl(nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id),t4.hospital_id),t5.hospital_id),t6.hospital_id),t7.hospital_id) as hospital_id
  ,nvl(nvl(nvl(nvl(nvl(nvl(t1.city_name,t2.city_name),t3.city_name),t4.city_name),t5.city_name),t6.city_name),t7.city_name) as city_name
  --,nvl(nvl(nvl(nvl(t1.business_group_name,t2.business_group_name),t3.business_group_name),t4.business_group_name),t5.business_group_name) as `商务组`
  ,NVL(hexin_exp_pv,0) AS hexin_exp_pv
  ,nvl(service_exp_pv,0) as service_exp_pv
  ,nvl(doc_hos_exp_pv,0)  as doc_hos_exp_pv
  ,nvl(hexin_pv,0) as hexin_pv
  ,nvl(service_page_pv ,0) as service_page_pv
  ,nvl(doc_hos_page_pv,0) as doc_hos_page_pv
  ,nvl(click_pv,0) as click_pv
  ,nvl(clue_num,0) as clue_num
  ,nvl(ord_num,0) as ord_num
  ,nvl(service_price,0) as service_price
  ,nvl(discount,0) as discount
  ,nvl(recharge_amount,0) as recharge_amount
  ,nvl(chongzhi_amount,0) as chongzhi_amount
  ,nvl(all_amount,0) as all_amount
  ,nvl(cpc_amount,0) as cpc_amount
  ,nvl(cpc_chongzhi_amount,0) as cpc_chongzhi_amount
  ,nvl(cpc_click_num,0) as cpc_click_num
  ,nvl(liulan_amount,0) as liulan_amount
  ,nvl(sixin_amount,0) as sixin_amount
FROM
---医生医院、美购页pv
(
  SELECT
  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
  ,SUM(doc_hos_pv) as doc_hos_page_pv
  ,SUM(service_pv) as service_page_pv
  ,SUM(hexin_pv) as hexin_pv
  FROM
  (
    SELECT  --之前是根据merchant_id算的，有重复，如果按doctor_id值不会重复
      partition_date,doctor_id,SUM(case when business_type in ('org','doctor') then pv_num end) as doc_hos_pv,SUM(case when business_type = 'service' then pv_num end) as service_pv,SUM(pv_num) as hexin_pv
    FROM  online.ml_doctor_event_indic_day
    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
    AND partition_date <=regexp_replace(date_sub(current_date(),1),'-','')
    AND merchant_id IS NOT NULL
    AND merchant_id <> ''
    AND business_type IN ('service','org', 'doctor')
    AND data_type = 'pv'
    AND cl_id <> ''
    AND cl_id <> '0'
    GROUP BY  partition_date,doctor_id
  )a
  LEFT JOIN
  ( --商务归属1009更新
    --！！ 注意：这里的日期变量设置为当前日期的前一天，定时任务为每月第一天，故查询的为上月最后一天的归属
    SELECT
         doctor_id,city_name,hospital_id,hospital_name
    FROM
    online.ml_doctor_relation_dimen_day
    WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
    AND hospital_is_online='true'
    GROUP BY doctor_id,city_name,hospital_id,hospital_name
  )b
  ON a.doctor_id=b.doctor_id
  GROUP BY  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
)t1

FULL JOIN ---医生医院、美购页曝光
(
  SELECT
  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
  ,SUM(CASE WHEN type='service' THEN exp_pv END) as service_exp_pv
  ,SUM(CASE WHEN type<>'service' THEN exp_pv END) as doc_hos_exp_pv
  ,SUM(exp_pv) as hexin_exp_pv
  FROM
  (
    SELECT partition_date,doctor_id,SUM(pv_num) as exp_pv,'service' as type
    FROM  online.ml_doctor_event_indic_day
    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
    AND partition_date <=regexp_replace(date_sub(current_date(),1),'-','')
    AND merchant_id IS NOT NULL
    AND merchant_id <> ''
    AND business_type ='service'
    AND data_type = 'native_exposure'
    AND cl_id <> ''
    AND cl_id <> '0'
    GROUP BY  partition_date,doctor_id,'service'

    UNION ALL
    SELECT partition_date,card_id as doctor_id,count(1) as exp_pv,'doc_hos'as type
    FROM  online.ml_community_precise_exposure_detail
    WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
    AND partition_date <=regexp_replace(date_sub(current_date(),1),'-','')
    AND card_content_type = 'doctor'
    AND card_id <>''
    AND cl_id <> ''
    AND cl_id <> '0'
    GROUP BY  partition_date,card_id,'doc_hos'

    UNION ALL
    SELECT partition_date,doctor_id,SUM(exp_pv) as exp_pv,'doc_hos'as type
    FROM
    (
      SELECT partition_date,card_id as hospital_id,count(1) as exp_pv
      FROM  online.ml_community_precise_exposure_detail
      WHERE partition_date >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
      AND partition_date <=regexp_replace(date_sub(current_date(),1),'-','')
      AND card_content_type = 'hospital'
      AND card_id <>''
      AND cl_id <> ''
      AND cl_id <> '0'
      GROUP BY  partition_date,card_id
    )a
    LEFT JOIN
    (
      SELECT id AS doctor_id,hospital_id
      FROM online.tl_hdfs_doctor_view
      WHERE partition_date = regexp_replace(date_sub(current_date(),1),'-','')
      AND doctor_type  = '1'
    )b
    ON a.hospital_id=b.hospital_id
    GROUP BY partition_date,doctor_id,'doc_hos'
  )a
  LEFT JOIN
  ( --商务归属1009更新
    --！！ 注意：这里的日期变量设置为当前日期的前一天，定时任务为每月第一天，故查询的为上月最后一天的归属
    SELECT
         doctor_id,city_name,hospital_name,hospital_id
    FROM
    online.ml_doctor_relation_dimen_day
    WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
    AND hospital_is_online='true'
    GROUP BY doctor_id,city_name,hospital_name,hospital_id
  )b
  ON a.doctor_id=b.doctor_id
  GROUP BY  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
)t2
  ON t1.partition_date=t2.partition_date AND t1.hospital_name=t2.hospital_name
  AND t1.hospital_id=t2.hospital_id AND t1.city_name=t2.city_name

FULL JOIN
(
  SELECT DATA_DAY as partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
  ,SUM(clue_num) as clue_num
  FROM
  (--有效线索分日数据
      SELECT
          DATA_DAY,merchant_id,count(1) AS clue_num
      FROM
      (
          SELECT NVL(T1.USER_ID,T2.USER_ID) AS USER_ID,
                  NVL(T1.merchant_id,T2.merchant_id) AS merchant_id,
                  NVL(T1.DATA_MONTH,T2.CALL_MONTH) AS DATA_MONTH,
                  least(NVL(DATA_DAY,'99999999'),NVL(FIRST_CALL_DATE,'99999999')) AS DATA_DAY,
                  NVL(T1.CONSULT_NUM,0) AS CONSULT_NUM,
                  NVL(T1.PAY_NUM,0) AS PAY_NUM,
                  NVL(T2.call_num,0) AS CALL_NUM
          FROM
          (
              SELECT
                  NVL(T3.USER_ID,T4.USER_ID) AS USER_ID,
                  NVL(T3.merchant_id,T4.merchant_id) AS merchant_id,
                  NVL(T3.CONSULT_MONTH,T4.PAY_MONTH) AS DATA_MONTH,
                  least(NVL(first_consult_date,'99999999'),NVL(FIRST_PAY_DATE,'99999999')) AS DATA_DAY,
                  NVL(T3.CONSULT_NUM,0) AS CONSULT_NUM,
                  NVL(T4.PAY_NUM,0) AS PAY_NUM
              FROM
              (
                  SELECT
                      user_id
                      ,merchant_id
                      ,substr(partition_day,1,6) AS consult_month
                      ,min(partition_day) AS first_consult_date
                      ,1 AS consult_num
                  FROM  ml.ML_C_ET_MSG_CONVERSATION_DIMEN_INC_D
                  WHERE
                      partition_day  >=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
                      AND partition_day <= regexp_replace(date_sub(current_date(),1),'-','')
                      AND is_valid='true'
                      AND merchant_id IS NOT NULL
                  GROUP BY user_id,merchant_id,substr(partition_day,1,6)
              )T3
              FULL JOIN
              (
                  SELECT
                      T.USER_ID,
                      T.merchant_id,
                      regexp_replace(SUBSTR(T.PAY_DATE,1,7),'-','') AS PAY_MONTH,
                      MIN(regexp_replace(SUBSTR(T.PAY_DATE,1,10),'-','')) AS FIRST_PAY_DATE,
                      1 AS PAY_NUM
                  FROM  ONLINE.ML_TRADE_ORDER_DETAIL_DAY T
                  WHERE
                      T.PARTITION_DATE = regexp_replace(date_sub(current_date(),1),'-','')
                      AND regexp_replace(substr(T.PAY_DATE,1,10),'-','') >=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
                      AND regexp_replace(substr(T.PAY_DATE,1,10),'-','') <= regexp_replace(date_sub(current_date(),1),'-','')
                      AND T.is_pure_user='true'
                  GROUP BY T.USER_ID,T.merchant_id,regexp_replace(SUBSTR(T.PAY_DATE,1,7),'-','')
              ) T4
              ON T3.USER_ID = T4.USER_ID AND T3.merchant_id = T4.merchant_id AND T3.CONSULT_MONTH = T4.PAY_MONTH
              GROUP BY NVL(T3.USER_ID,T4.USER_ID),NVL(T3.merchant_id,T4.merchant_id),NVL(T3.CONSULT_MONTH,T4.PAY_MONTH),
                  least(NVL(first_consult_date,'99999999'),NVL(FIRST_PAY_DATE,'99999999')),NVL(T3.CONSULT_NUM,0),NVL(T4.PAY_NUM,0)
          )T1

          FULL JOIN
          (
              SELECT user_id,merchant_id,regexp_replace(SUBSTR(a.partition_date,1,6),'-','') AS CALL_MONTH,
              MIN(partition_date) as FIRST_CALL_DATE,1 AS call_num
              FROM
              (
                  SELECT sub_id,REGEXP_REPLACE(SUBSTR(call_time,0,10), '-', '') as partition_date
                  FROM  tl.tl_gm_sl_ali_virtual_phone_call_detail --通话记录表，call_type呼叫类型
                  WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
                  AND REGEXP_REPLACE(SUBSTR(call_time,0,10), '-', '')>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
                  AND REGEXP_REPLACE(SUBSTR(call_time,0,10), '-', '')<=regexp_replace(date_sub(current_date(),1),'-','')
                  --AND start_time+ interval 30 second <= release_time --通话时长大于30秒
                  AND release_time>start_time
              )a
              LEFT JOIN
              (
                  SELECT id,sub_id
                  FROM tl.tl_gm_sl_ali_virtual_phone_binding --阿里记录表
                  WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
              )b
                  ON a.sub_id = b.sub_id
              LEFT JOIN
              (
                  SELECT id,platform_binding_id
                  FROM tl.tl_gm_sl_virtual_phone_binding
                  WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
              )c
                  ON b.id = c.platform_binding_id
              LEFT JOIN
              (
                  SELECT phone_binding_id,lead_task_id
                  FROM tl.tl_gm_sl_lead_task_phone_binding
                  WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
              )d
                  ON c.id = d.phone_binding_id
              JOIN
              (
                  SELECT id,user_id,merchant_id
                  FROM tl.tl_gm_sl_lead_task  --线索任务表（用户点击授权后记入该表）
                  WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
                  AND source='2' --用户行为电话授权
                  AND (USER_ID is NOT NULL or USER_ID <>'')
              )e
                  ON d.lead_task_id = e.id
              GROUP BY user_id,merchant_id,regexp_replace(SUBSTR(a.partition_date,1,6),'-','')
          )T2
          ON T1.USER_ID = T2.USER_ID AND T1.merchant_id = T2.merchant_id AND T1.DATA_MONTH = T2.CALL_MONTH
      )T1
      GROUP BY DATA_DAY,merchant_id
  )t3

  LEFT JOIN
  ( --商务归属1009更新
    --！！ 注意：这里的日期变量设置为当前日期的前一天，定时任务为每月第一天，故查询的为上月最后一天的归属
    SELECT
         merchant_id,city_name,hospital_name,hospital_id
    FROM
    online.ml_doctor_relation_dimen_day
    WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
    AND doctor_is_merchant='true'
    AND hospital_is_online='true'
    GROUP BY merchant_id,city_name,hospital_name,hospital_id
  )b
  ON t3.merchant_id=b.merchant_id
  GROUP BY  DATA_DAY
  ,hospital_name
  ,hospital_id
  ,city_name
)t3
  on nvl(t1.partition_date,t2.partition_date)=t3.partition_date
  and nvl(t1.hospital_name,t2.hospital_name)=t3.hospital_name
  AND nvl(t1.hospital_id,t2.hospital_id)=t3.hospital_id
  AND nvl(t1.city_name,t2.city_name)=t3.city_name

FULL JOIN
( --验证人次
    SELECT validate_date as partition_date,hospital_name,hospital_id,city_name,SUM(ord_num) as ord_num
    FROM
    (
        SELECT min(REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', '')) as validate_date,merchant_id,user_id,REGEXP_REPLACE(SUBSTR(validate_time, 1, 7), '-', '') as month,'1' as ord_num
        FROM online.ml_trade_order_detail_day
        WHERE partition_date = regexp_replace(date_sub(current_date(),1),'-','')
          AND REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', '') >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', '') <= regexp_replace(date_sub(current_date(),1),'-','')
          AND is_pure_user = 'true'   --取纯用户
          GROUP BY merchant_id,user_id,REGEXP_REPLACE(SUBSTR(validate_time, 1, 7), '-', '')
    )ord
    LEFT JOIN
    (
      SELECT merchant_id,city_name,hospital_name,hospital_id
      FROM online.ml_doctor_relation_dimen_day
      WHERE partition_date=regexp_replace(date_sub(current_date(),1),'-','')
      AND hospital_is_online='true'
      AND doctor_is_merchant='true'
      GROUP BY merchant_id,city_name,hospital_name,hospital_id
    )doc
      on ord.merchant_id = doc.merchant_id
    GROUP BY validate_date,hospital_name,hospital_id,city_name
)t4
  on nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date)=t4.partition_date
  and nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name) =t4.hospital_name
  AND nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id)=t4.hospital_id
  AND nvl(nvl(t1.city_name,t2.city_name),t3.city_name)=t4.city_name

FULL JOIN ---医生医院、美购页线索点击
(
  SELECT
  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
  ,count(cl_id) as click_pv
  FROM
  (
    SELECT SUBSTR(partition_date,1,6) as month,cl_id,merchant_id,min(partition_date) as partition_date
    FROM
    (
        SELECT partition_date,cl_id,doctor_id,SUM(click_pv) as click_pv --美购页线索点击
        FROM
        (
          SELECT partition_date,cl_id,nvl(params['service_id'],params['business_id']) as service_id,count(1) as click_pv
          FROM  online.bl_hdfs_maidian_updates
          WHERE partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND partition_date<=regexp_replace(date_sub(current_date(),1),'-','')
          AND ((action = 'welfare_multiattribute_click_buy' AND page_name = 'welfare_detail')
            or action = 'welfare_detail_click_message'
            or (action ='on_click_button' AND page_name ='welfare_detail'  AND params['popup_name'] in ('consult_reserved','consult_call') AND params['button_name'] in ('message','call','reserved')))
          AND cl_id <> ''
          AND cl_id <> '0'
          AND nvl(params['service_id'],params['business_id']) <>''
          GROUP BY partition_date,cl_id,nvl(params['service_id'],params['business_id'])
        )a
        LEFT JOIN
        (
          SELECT id,doctor_id
          FROM online.tl_meigou_service_view   --美购表
          where  partition_date = regexp_replace(date_sub(current_date(),1),'-','')
        )b
        ON a.service_id=b.id
        GROUP BY partition_date,cl_id,doctor_id

        UNION ALL
        SELECT partition_date,cl_id,params['business_id'] as doctor_id,count(1) as click_pv
        FROM  online.bl_hdfs_maidian_updates
        WHERE partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
        AND partition_date<=regexp_replace(date_sub(current_date(),1),'-','')
        AND ((action ='on_click_button' AND page_name='expert_detail' AND params['button_name'] in ('discount_pay','phone_consult','online_consult','message','call','reserved'))
          or action='online_consult')
        AND params['business_id'] <>''
        AND cl_id <> ''
        AND cl_id <> '0'
        GROUP BY  partition_date,cl_id,params['business_id']

        UNION ALL
        SELECT partition_date,cl_id,doctor_id,SUM(click_pv) as click_pv
        FROM
        (
          SELECT partition_date,cl_id,params['business_id'] as hospital_id,count(1) as click_pv  --医院页线索点击
          FROM  online.bl_hdfs_maidian_updates
          WHERE partition_date>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND partition_date<=regexp_replace(date_sub(current_date(),1),'-','')
          AND action ='on_click_button' AND page_name='organization_detail' AND params['button_name'] in ('phone_consult','online_consult','message','call','reserved')
          AND params['business_id'] <>''
          AND cl_id <> ''
          AND cl_id <> '0'
          GROUP BY  partition_date,cl_id,params['business_id']
        )a
        LEFT JOIN
        (
          SELECT id AS doctor_id,hospital_id
          FROM online.tl_hdfs_doctor_view
          WHERE partition_date = regexp_replace(date_sub(current_date(),1),'-','')
          AND doctor_type  = '1'
        )b
        ON a.hospital_id=b.hospital_id
        GROUP BY partition_date,cl_id,doctor_id
    )a
    LEFT JOIN
    (
      SELECT doctor_id,merchant_id
      FROM online.ml_doctor_relation_dimen_day
      WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
      AND merchant_id <>''
      GROUP BY doctor_id,merchant_id
    )b
    ON a.doctor_id=b.doctor_id
    GROUP BY SUBSTR(partition_date,1,6),cl_id,merchant_id
  )a
  LEFT JOIN
  ( --商务归属1009更新
    --！！ 注意：这里的日期变量设置为当前日期的前一天，定时任务为每月第一天，故查询的为上月最后一天的归属
    SELECT
         merchant_id,city_name,hospital_name,hospital_id
    FROM
    online.ml_doctor_relation_dimen_day
    WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
    AND doctor_is_merchant='true'
    AND hospital_is_online='true'
    GROUP BY merchant_id,city_name,hospital_name,hospital_id
  )b
  ON a.merchant_id=b.merchant_id
  GROUP BY  a.partition_date
  ,hospital_name
  ,hospital_id
  ,city_name
)t5
  on nvl(nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date),t4.partition_date)=t5.partition_date
  and nvl(nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name),t4.hospital_name)=t5.hospital_name
  AND nvl(nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id),t4.hospital_id)=t5.hospital_id
  AND nvl(nvl(nvl(t1.city_name,t2.city_name),t3.city_name),t4.city_name)=t5.city_name

FULL JOIN
(
    SELECT nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date) as partition_date
    ,nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name) as hospital_name
    ,nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id) as hospital_id
    ,nvl(nvl(t1.city_name,t2.city_name),t3.city_name) as city_name
    ,nvl(discount,0) as discount
    ,nvl(recharge_amount,0) as recharge_amount
    ,nvl(all_amount,0) as all_amount
    ,nvl(chongzhi_amount,0) as chongzhi_amount
    ,nvl(cpc_amount,0) as cpc_amount
    ,nvl(cpc_chongzhi_amount,0) as cpc_chongzhi_amount
    ,nvl(cpc_click_num,0) as cpc_click_num
    ,nvl(liulan_amount,0) as liulan_amount
    ,nvl(sixin_amount,0) as sixin_amount
    FROM
    (
      --佣金（订单验证抽成+一般补单（常规补单+罚款）+买单+剔除转诊关联的订单
      SELECT partition_date,city_name,hospital_id,hospital_name,SUM(money1) as discount
      FROM
      (
          SELECT SUBSTR(REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', ''),1,8) as partition_date,doctor_id,sum(discount) as money1
          FROM online.ml_trade_order_detail_day   --美购交易表
          WHERE partition_date = regexp_replace(date_sub(current_date(),1),'-','')
          AND REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', '') >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', '') <= regexp_replace(date_sub(current_date(),1),'-','')
          AND status <> '3'   --去除已退款
          AND is_referral_order ='false'  --去除转诊关联的订单
          GROUP BY REGEXP_REPLACE(SUBSTR(validate_time, 1, 10), '-', ''),doctor_id

          UNION ALL
          SELECT SUBSTR(REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', ''),1,8) as partition_date,doctor_id,sum(amount) as money1
          FROM online.tl_hdfs_budanluru_view   --补单录入表
          WHERE partition_date = '${partition_date}'
          AND REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '') >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '') <= regexp_replace(date_sub(current_date(),1),'-','')
          AND status = 0  --已录入
          AND type in ('0','2')  --常规补单和罚款
          GROUP BY REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', ''),doctor_id

          UNION ALL
          SELECT SUBSTR(REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', ''),1,8) as partition_date,doctor_id,sum(discount_cent)/100 as money1
          FROM online.tl_maidan_order_view   --买单表
          WHERE partition_date = '${partition_date}'
          AND REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '') >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '') <= regexp_replace(date_sub(current_date(),1),'-','')
          AND status ='1'
          GROUP BY REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', ''),doctor_id
      )ord
      LEFT JOIN
      (
        SELECT doctor_id,city_name,hospital_id,hospital_name
        FROM online.ml_doctor_relation_dimen_day
        WHERE partition_date=regexp_replace(date_sub(current_date(),1),'-','')
        AND hospital_is_online='true'
        GROUP BY doctor_id,city_name,hospital_id,hospital_name
      )doc
        on ord.doctor_id = doc.doctor_id
      GROUP BY partition_date,city_name,hospital_id,hospital_name
    )t1

    FULL JOIN
    ( --广告充值
      SELECT partition_date,hospital_name,hospital_id,city_name,SUM(recharge_amount) as recharge_amount
      FROM
      (
          SELECT SUBSTR(partition_day,1,8) as partition_date,merchant_id,sum(proportion_recharge_amount) as recharge_amount  --当天充值金额
          FROM ml.ml_c_ct_mc_merchant_indic_d
          WHERE partition_day >=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND partition_day <= regexp_replace(date_sub(current_date(),1),'-','')
          GROUP BY SUBSTR(partition_day,1,8),merchant_id
      )gg
      LEFT JOIN
      (
        SELECT merchant_id,city_name,hospital_name,hospital_id
        FROM online.ml_doctor_relation_dimen_day
        WHERE partition_date=regexp_replace(date_sub(current_date(),1),'-','')
        AND doctor_is_merchant = 'true'
        AND hospital_is_online='true'
        GROUP BY merchant_id,city_name,hospital_name,hospital_id
      )doc
        on gg.merchant_id = doc.merchant_id
        GROUP BY partition_date,hospital_id,hospital_name,city_name
    )t2
    on t1.partition_date=t2.partition_date AND t1.hospital_id=t2.hospital_id AND t1.hospital_name=t2.hospital_name  AND t1.city_name=t2.city_name

    FULL JOIN
    (--广告充值消耗（报表口径）
      SELECT partition_date,hospital_id,hospital_name,city_name,SUM(all_amount) as all_amount,SUM(chongzhi_amount) as chongzhi_amount
          ,SUM(cpc_amount) as cpc_amount,SUM(cpc_chongzhi_amount) as cpc_chongzhi_amount,SUM(cpc_click_num) as cpc_click_num,SUM(liulan_amount) as liulan_amount,SUM(sixin_amount) as sixin_amount
      FROM
      (
          SELECT SUBSTR(partition_day,1,8) as partition_date,merchant_id
          ,SUM(CASE WHEN advertise_type = 'cpc' AND advertise_calculate_type = 'cpc_flownext' THEN
                 proportion_expend_recharge_amount
                WHEN advertise_type = 'cpt' AND advertise_calculate_type = 'cpt_schedule' THEN
                 proportion_expend_recharge_amount
                WHEN advertise_type IN ('browse', 'message', 'valueadded','rechargededuction') THEN
                 proportion_expend_recharge_amount
                WHEN advertise_type = 'adjustment' AND advertise_calculate_type ='adjustment_flow' THEN
                 proportion_expend_recharge_amount
                ELSE
                 0
              END) chongzhi_amount  --广告充值总消耗（等比例）
          ,SUM(CASE WHEN advertise_type = 'cpc' AND advertise_calculate_type = 'cpc_flownext' THEN
                 proportion_expend_amount
                WHEN advertise_type = 'cpt' AND advertise_calculate_type = 'cpt_schedule' THEN
                 proportion_expend_amount
                WHEN advertise_type IN ('browse', 'message', 'valueadded','rechargededuction') THEN
                 proportion_expend_amount
                WHEN advertise_type = 'adjustment' AND advertise_calculate_type ='adjustment_flow' THEN
                 proportion_expend_amount
                ELSE
                 0
              END) all_amount  --广告总消耗（含返点等比例）
          ,SUM(CASE WHEN advertise_type = 'cpc' AND advertise_calculate_type = 'cpc_flownext' THEN proportion_expend_amount END) as cpc_amount  --cpc总消耗
          ,SUM(CASE WHEN advertise_type = 'cpc' AND advertise_calculate_type = 'cpc_flownext' THEN proportion_expend_recharge_amount END) as cpc_chongzhi_amount  --cpc充值消耗
          ,SUM(case when advertise_type = 'cpc' AND advertise_business_type in('service') and advertise_calculate_type='cpc_log' then cpc_click_num end)   cpc_click_num  ---当天cpc商品点击量
          ,SUM(CASE WHEN advertise_type='browse' THEN proportion_expend_recharge_amount END) as liulan_amount  --浏览收入(不含返点)
          ,SUM(CASE WHEN advertise_type='message' THEN proportion_expend_recharge_amount END) as sixin_amount  --私信收入(不含返点)
          from ml.ml_c_ct_mc_merchantadclassify_indic_d
          where partition_day>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
          AND partition_day <=regexp_replace(date_sub(current_date(),1),'-','')
          group by SUBSTR(partition_day,1,8),merchant_id

          UNION ALL
          SELECT SUBSTR(t1.dt,1,8) as partition_date,merchant_id,sum(rechange) as chongzhi_amount,''all_amount,''cpc_amount,''cpc_chongzhi_amount,''cpc_click_num,''liulan_amount,''sixin_amount
          FROM
          (
            SELECT
            b.doctor_id,dt
            ,sum(rechange) as rechange  --转诊充值消耗
            FROM
            (
                SELECT account_id,abs(rechange) as rechange,REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '') as dt
                FROM  tl.tl_ap_account_accountflow--流水表
                WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
                and REGEXP_REPLACE(SUBSTR(created_time, 1, 10), '-', '')>=REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
                and REGEXP_REPLACE(SUBSTR(created_time,1,10),'-','')<=regexp_replace(date_sub(current_date(),1),'-','')
                and type='16'--转诊消耗
            )a
            LEFT JOIN
            (
                SELECT id,doctor_id
                FROM tl.tl_ap_account_account
                WHERE partition_day=regexp_replace(date_sub(current_date(),1),'-','')
                GROUP BY id,doctor_id
            )b
              on a.account_id=b.id
              GROUP BY b.doctor_id,dt
          )t1
          LEFT JOIN
          (
            SELECT doctor_id,merchant_id
            FROM online.ml_doctor_relation_dimen_day
            WHERE partition_date = regexp_replace(date_sub(current_date(),1),'-','')
            and doctor_is_merchant='true'
            GROUP BY doctor_id,merchant_id
          )t2
          on t1.doctor_id=t2.doctor_id
          GROUP BY SUBSTR(t1.dt,1,8),merchant_id
      )gg
      LEFT JOIN
      (
        SELECT merchant_id,city_name,hospital_name,hospital_id
        FROM online.ml_doctor_relation_dimen_day
        WHERE partition_date=regexp_replace(date_sub(current_date(),1),'-','')
        AND doctor_is_merchant = 'true'
        AND hospital_is_online='true'
        GROUP BY merchant_id,city_name,hospital_name,hospital_id
      )doc
        on gg.merchant_id = doc.merchant_id
        GROUP BY partition_date,hospital_id,hospital_name,city_name
    )t3
    on nvl(t1.partition_date,t2.partition_date)=t3.partition_date
    and nvl(t1.hospital_id,t2.hospital_id)=t3.hospital_id
    AND nvl(t1.hospital_name,t2.hospital_name)=t3.hospital_name
    AND nvl(t1.city_name,t2.city_name)=t3.city_name
)t6
  on nvl(nvl(nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date),t4.partition_date),t5.partition_date)=t6.partition_date
  and nvl(nvl(nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name),t4.hospital_name),t5.hospital_name)=t6.hospital_name
  AND nvl(nvl(nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id),t4.hospital_id),t5.hospital_id)=t6.hospital_id
  AND nvl(nvl(nvl(nvl(t1.city_name,t2.city_name),t3.city_name),t4.city_name),t5.city_name)=t6.city_name

FULL JOIN
( --纯用户支付gmv
    SELECT pay_date as partition_date,hospital_name,hospital_id,city_name,SUM(service_price) as service_price
    FROM
    (
      SELECT REGEXP_REPLACE(SUBSTR(pay_time, 1, 10), '-', '') as pay_date,doctor_id,sum(service_price) as service_price
      FROM online.ml_trade_order_detail_day
      WHERE partition_date =regexp_replace(date_sub(current_date(),1),'-','')
        AND REGEXP_REPLACE(SUBSTR(pay_time, 1, 10), '-', '') >= REGEXP_REPLACE(trunc(date_sub(current_date(),8),'MM'),'-','')
        AND REGEXP_REPLACE(SUBSTR(pay_time, 1, 10), '-', '') <= regexp_replace(date_sub(current_date(),1),'-','')
        AND is_pure_user = 'true'   --取纯用户
        GROUP BY REGEXP_REPLACE(SUBSTR(pay_time, 1, 10), '-', ''),doctor_id
    )ord
    LEFT JOIN
    (
      SELECT doctor_id,city_name,hospital_name,hospital_id
      FROM online.ml_doctor_relation_dimen_day
      WHERE partition_date=regexp_replace(date_sub(current_date(),1),'-','')
      AND hospital_is_online='true'
      GROUP BY doctor_id,city_name,hospital_name,hospital_id
    )doc
      on ord.doctor_id = doc.doctor_id
    GROUP BY pay_date,hospital_name,hospital_id,city_name
)t7
  on nvl(nvl(nvl(nvl(nvl(t1.partition_date,t2.partition_date),t3.partition_date),t4.partition_date),t5.partition_date),t6.partition_date)=t7.partition_date
  and nvl(nvl(nvl(nvl(nvl(t1.hospital_name,t2.hospital_name),t3.hospital_name),t4.hospital_name),t5.hospital_name),t6.hospital_name)=t7.hospital_name
  AND nvl(nvl(nvl(nvl(nvl(t1.hospital_id,t2.hospital_id),t3.hospital_id),t4.hospital_id),t5.hospital_id),t6.hospital_id)=t7.hospital_id
  AND nvl(nvl(nvl(nvl(nvl(t1.city_name,t2.city_name),t3.city_name),t4.city_name),t5.city_name),t6.city_name)=t7.city_name
  order by data desc

















